Imports System.IO
Imports System.Web.Services.Protocols

Public Class WebForm1
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    Protected WithEvents lstContent As System.Web.UI.WebControls.ListBox
    Protected WithEvents Label1 As System.Web.UI.WebControls.Label
    Protected WithEvents lblPath As System.Web.UI.WebControls.Label
    Protected WithEvents btnOpen As System.Web.UI.WebControls.Button
    Protected WithEvents btnBack As System.Web.UI.WebControls.Button
    Protected WithEvents Label5 As System.Web.UI.WebControls.Label
    Protected WithEvents Label6 As System.Web.UI.WebControls.Label
    Protected WithEvents Label3 As System.Web.UI.WebControls.Label
    Protected WithEvents Label2 As System.Web.UI.WebControls.Label
    Protected WithEvents Label4 As System.Web.UI.WebControls.Label
    Protected WithEvents lblPrompt As System.Web.UI.WebControls.Label
    Protected WithEvents Label7 As System.Web.UI.WebControls.Label
    Protected WithEvents txtInput As System.Web.UI.WebControls.TextBox
    Protected WithEvents lstOutput As System.Web.UI.WebControls.ListBox
    Protected WithEvents lblOutput As System.Web.UI.WebControls.Label
    Protected WithEvents lblParam1 As System.Web.UI.WebControls.Label
    Protected WithEvents lblParam2 As System.Web.UI.WebControls.Label
    Protected WithEvents lblParam3 As System.Web.UI.WebControls.Label
    Protected WithEvents lblParam4 As System.Web.UI.WebControls.Label
    Protected WithEvents txtParam1 As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtParam2 As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtParam3 As System.Web.UI.WebControls.TextBox
    Protected WithEvents txtParam4 As System.Web.UI.WebControls.TextBox
    Protected WithEvents cboParam1 As System.Web.UI.WebControls.DropDownList
    Protected WithEvents cboParam2 As System.Web.UI.WebControls.DropDownList
    Protected WithEvents cboParam3 As System.Web.UI.WebControls.DropDownList
    Protected WithEvents cboParam4 As System.Web.UI.WebControls.DropDownList
    Protected WithEvents cboMethod As System.Web.UI.WebControls.DropDownList
    Protected WithEvents lblReportParameters As System.Web.UI.WebControls.Label
    Protected WithEvents cmdExecuteReport As System.Web.UI.WebControls.Button
    Protected WithEvents cmdExecuteMethod As System.Web.UI.WebControls.Button
    Protected WithEvents cmdGeneric As System.Web.UI.WebControls.Button

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    ' An instance of the Reporting Services Web Service to be used by all methods.
    Private oRS As localhost.ReportingService = New localhost.ReportingService

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim LogonCredentials As System.Net.NetworkCredential

        ' Set the credentials.
        LogonCredentials = New System.Net.NetworkCredential("UserName", "Password", "Domain")
        oRS.Credentials = LogonCredentials
        oRS.PreAuthenticate = True

        If Not IsPostBack Then
            lblPath.Text = "/"

            ' Get the contents of the Home folder.
            GetFolderContents()
        End If

    End Sub

    Private Sub GetDataSourceContents(ByVal DataSourcePath As String)
        Dim Contents As localhost.DataSourceDefinition

        ' Hide the items on the right side of the page.
        HideRight()

        ' Get the contents of the data source
        Contents = oRS.GetDataSourceContents(DataSourcePath)

        ' Set the output label.
        lblOutput.Text = "Data Source Contents"
        lblOutput.Visible = True

        ' Put the data source contents in the output list.
        lstOutput.Items.Clear()
        lstOutput.Visible = True
        lstOutput.Items.Add("Extension:")
        lstOutput.Items.Add(Contents.Extension)
        lstOutput.Items.Add("")
        lstOutput.Items.Add("Connection String:")
        lstOutput.Items.Add(Contents.ConnectString)
        lstOutput.Items.Add("")
        If Contents.CredentialRetrieval = localhost.CredentialRetrievalEnum.Store Then
            lstOutput.Items.Add("User Name:")
            lstOutput.Items.Add(Contents.UserName)
            lstOutput.Items.Add("")
            If Contents.WindowsCredentials Then
                lstOutput.Items.Add("Windows Login")
            Else
                lstOutput.Items.Add("SQL Login")
            End If
            If Contents.ImpersonateUser Then
                lstOutput.Items.Add("")
                lstOutput.Items.Add("Impersonate User")
            End If
        ElseIf Contents.CredentialRetrieval = localhost.CredentialRetrievalEnum.Integrated Then
            lstOutput.Items.Add("Windows NT Integrated Security")
        ElseIf Contents.CredentialRetrieval = localhost.CredentialRetrievalEnum.Prompt Then
            lstOutput.Items.Add("User is prompted for Login the the following prompt:")
            lstOutput.Items.Add(Contents.Prompt)
        Else
            lstOutput.Items.Add("No Login required")
        End If
    End Sub
    Private Sub GetFolderContents()
        Dim Path As String
        Dim Contents() As localhost.CatalogItem
        Dim Item As localhost.CatalogItem
        Dim ListEntry As String

        ' Hide the items on the right side of the page.
        HideRight()

        ' Get the path.
        Path = lblPath.Text

        ' Get the contents of the folder.
        Contents = oRS.ListChildren(Path, False)

        ' Clear the content list.
        lstContent.Items.Clear()

        ' Add the item to the list.
        For Each Item In Contents
            If Item.Type = localhost.ItemTypeEnum.DataSource Then
                ListEntry = "DSC: "
            ElseIf Item.Type = localhost.ItemTypeEnum.Folder Then
                ListEntry = "FLD: "
            ElseIf Item.Type = localhost.ItemTypeEnum.LinkedReport Then
                ListEntry = "LNK: "
            ElseIf Item.Type = localhost.ItemTypeEnum.Report Then
                ListEntry = "RPT: "
            ElseIf Item.Type = localhost.ItemTypeEnum.Resource Then
                ListEntry = "RSC: "
            ElseIf Item.Type = localhost.ItemTypeEnum.Unknown Then
                ListEntry = "UNK: "
            End If

            ListEntry = ListEntry & Item.Name
            lstContent.Items.Add(ListEntry)
        Next

        lstContent.SelectedIndex = 0

    End Sub

    Private Sub GetReportContents(ByVal ReportPath As String)
        ' The rendering format for the report.
        Dim format As String = "HTML4.0"
        Dim report As Byte() = Nothing
        Dim ReportParams As localhost.ReportParameter()
        Dim ReportParam As localhost.ReportParameter
        Dim ValidValue As localhost.ValidValue
        Dim ParamValues As localhost.ParameterValue() = Nothing
        Dim ParamValue As localhost.ParameterValue
        Dim ParamCount As Integer = 0
        Dim ItemCount As Integer

        ' The devInfo string tells the report viewer
        ' how to display with the report.
        ' The StreamRoot element points to a directory
        ' where this program will write the contents of 
        ' any resources for this report to access.
        Dim devInfo As String = _
        "<DeviceInfo>" + _
        "<Toolbar>True</Toolbar>" + _
        "<Parameters>True</Parameters>" + _
        "<DocMap>True</DocMap>" + _
        "<Zoom>100</Zoom>" + _
        "<StreamRoot>/RSWebServiceSample/Resources/</StreamRoot>" + _
        "</DeviceInfo>"

        ' Create variables for the remainder of the parameters
        Dim historyID As String = Nothing
        Dim credentials() As localhost.DataSourceCredentials = Nothing
        Dim showHideToggle As String = Nothing
        Dim encoding As String
        Dim mimeType As String
        Dim warnings() As localhost.Warning = Nothing
        Dim reportHistoryParameters() As localhost.ParameterValue = Nothing
        Dim streamIDs() As String = Nothing
        Dim streamID As String
        Dim resource As Byte()
        Dim sh As localhost.SessionHeader = New localhost.SessionHeader

        ' Hide he items on the right side of the page.
        HideRight()

        oRS.SessionHeaderValue = sh

        ' Get the parameters for the report.
        ReportParams = oRS.GetReportParameters(ReportPath, historyID, True, ParamValues, credentials)

        If ReportParams.Length > 0 Then
            lblReportParameters.Visible = True
            cmdExecuteReport.Visible = True

            For Each ReportParam In ReportParams
                ParamCount = ParamCount + 1

                If ParamCount = 1 Then
                    lblParam1.Visible = True
                    lblParam1.Text = ReportParam.Prompt
                    ViewState.Add("Param1Name", ReportParam.Name)
                    ViewState.Add("Param1Type", ReportParam.Type)
                    ViewState.Add("ParamCount", "1")

                    If Not (ReportParam.ValidValues Is Nothing) Then
                        ViewState.Add("Param1Ctrl", "List")
                        cboParam1.Items.Clear()
                        ItemCount = 0

                        For Each ValidValue In ReportParam.ValidValues
                            cboParam1.Items.Add(ValidValue.Label)
                            ItemCount = ItemCount + 1

                            cboParam1.Items(ItemCount - 1).Value = ValidValue.Value

                            If Not (ReportParam.DefaultValues Is Nothing) Then
                                If ValidValue.Value = ReportParam.DefaultValues(0) Then
                                    cboParam1.SelectedIndex = ItemCount - 1
                                End If
                            End If
                        Next
                        cboParam1.Visible = True
                    Else
                        ViewState.Add("Param1Ctrl", "Textbox")
                        txtParam1.Visible = True
                        If Not (ReportParam.DefaultValues Is Nothing) Then
                            txtParam1.Text = ReportParam.DefaultValues(0)
                        End If
                    End If
                ElseIf ParamCount = 2 Then
                    lblParam2.Visible = True
                    lblParam2.Text = ReportParam.Prompt
                    ViewState.Add("Param2Name", ReportParam.Name)
                    ViewState.Add("Param2Type", ReportParam.Type)
                    ViewState("ParamCount") = "2"

                    If Not (ReportParam.ValidValues Is Nothing) Then
                        ViewState.Add("Param2Ctrl", "List")
                        cboParam2.Items.Clear()
                        ItemCount = 0

                        For Each ValidValue In ReportParam.ValidValues
                            cboParam2.Items.Add(ValidValue.Label)
                            ItemCount = ItemCount + 1

                            cboParam2.Items(ItemCount - 1).Value = ValidValue.Value

                            If Not (ReportParam.DefaultValues Is Nothing) Then
                                If ValidValue.Value = ReportParam.DefaultValues(0) Then
                                    cboParam2.SelectedIndex = ItemCount - 1
                                End If
                            End If
                        Next

                        cboParam2.Visible = True
                    Else
                        ViewState.Add("Param2Ctrl", "Textbox")
                        txtParam2.Visible = True
                        If Not (ReportParam.DefaultValues Is Nothing) Then
                            txtParam2.Text = ReportParam.DefaultValues(0)
                        End If
                    End If
                ElseIf ParamCount = 3 Then
                    lblParam3.Visible = True
                    lblParam3.Text = ReportParam.Prompt
                    ViewState.Add("Param3Name", ReportParam.Name)
                    ViewState.Add("Param3Type", ReportParam.Type)
                    ViewState("ParamCount") = "3"

                    If Not (ReportParam.ValidValues Is Nothing) Then
                        ViewState.Add("Param3Ctrl", "List")
                        cboParam3.Items.Clear()
                        ItemCount = 0

                        For Each ValidValue In ReportParam.ValidValues
                            cboParam3.Items.Add(ValidValue.Label)
                            ItemCount = ItemCount + 1

                            cboParam3.Items(ItemCount - 1).Value = ValidValue.Value

                            If Not (ReportParam.DefaultValues Is Nothing) Then
                                If ValidValue.Value = ReportParam.DefaultValues(0) Then
                                    cboParam3.SelectedIndex = ItemCount - 1
                                End If
                            End If
                        Next

                        cboParam3.Visible = True
                    Else
                        ViewState.Add("Param3Ctrl", "Textbox")
                        txtParam3.Visible = True
                        If Not (ReportParam.DefaultValues Is Nothing) Then
                            txtParam3.Text = ReportParam.DefaultValues(0)
                        End If
                    End If
                ElseIf ParamCount = 4 Then
                    lblParam4.Visible = True
                    lblParam4.Text = ReportParam.Prompt
                    ViewState.Add("Param4Name", ReportParam.Name)
                    ViewState.Add("Param4Type", ReportParam.Type)
                    ViewState("ParamCount") = "4"
                    ReportParam.Type = localhost.ParameterTypeEnum.Boolean

                    If Not (ReportParam.ValidValues Is Nothing) Then
                        ViewState.Add("Param4Ctrl", "List")
                        cboParam4.Items.Clear()
                        ItemCount = 0

                        For Each ValidValue In ReportParam.ValidValues
                            cboParam4.Items.Add(ValidValue.Label)
                            ItemCount = ItemCount + 1

                            cboParam4.Items(ItemCount - 1).Value = ValidValue.Value

                            If Not (ReportParam.DefaultValues Is Nothing) Then
                                If ValidValue.Value = ReportParam.DefaultValues(0) Then
                                    cboParam4.SelectedIndex = ItemCount - 1
                                End If
                            End If
                        Next

                        cboParam4.Visible = True
                    Else
                        ViewState.Add("Param4Ctrl", "Textbox")
                        txtParam4.Visible = True
                        If Not (ReportParam.DefaultValues Is Nothing) Then
                            txtParam4.Text = ReportParam.DefaultValues(0)
                        End If
                    End If
                End If

                ViewState.Add("ReportPath", ReportPath)
            Next
        Else
            ViewState.Add("ParamCount", "0")

            DisplayReport(ReportPath)
        End If
    End Sub

    Private Sub DisplayReport(ByVal ReportPath As String)
        ' The rendering format for the report.
        Dim format As String = "HTML4.0"
        Dim report As Byte() = Nothing

        ' The devInfo string tells the report viewer
        ' how to display with the report.
        ' The StreamRoot element points to a directory
        ' where this program will write the contents of 
        ' any resources for this report to access.
        Dim devInfo As String = _
        "<DeviceInfo>" + _
        "<Toolbar>False</Toolbar>" + _
        "<Parameters>False</Parameters>" + _
        "<DocMap>True</DocMap>" + _
        "<Zoom>100</Zoom>" + _
        "<StreamRoot>/RSWebServiceSample/Resources/</StreamRoot>" + _
        "</DeviceInfo>"

        ' Create variables for the remainder of the parameters
        Dim historyID As String = Nothing
        Dim credentials() As localhost.DataSourceCredentials = Nothing
        Dim showHideToggle As String = Nothing
        Dim encoding As String
        Dim mimeType As String
        Dim warnings() As localhost.Warning = Nothing
        Dim reportHistoryParameters() As localhost.ParameterValue = Nothing
        Dim streamIDs() As String = Nothing
        Dim streamID As String
        Dim resource As Byte()
        Dim sh As localhost.SessionHeader = New localhost.SessionHeader
        Dim ParamCount As Integer

        ' Hide he items on the right side of the page.
        HideRight()

        oRS.SessionHeaderValue = sh

        ' Get the values of the parameters.
        ParamCount = Val(ViewState("ParamCount"))
        Dim parameters(ParamCount - 1) As localhost.ParameterValue
        Dim paramValue As localhost.ParameterValue

        Dim x As Integer
        Dim Name As String
        Dim Value As String
        Dim Type As localhost.ParameterTypeEnum

        If ParamCount > 0 Then
            For x = 1 To ParamCount
                If x = 1 Then
                    Name = ViewState("Param1Name")
                    Type = ViewState("Param1Type")
                    If ViewState("Param1Ctrl") = "Textbox" Then
                        Value = txtParam1.Text
                    Else
                        Value = cboParam1.SelectedValue
                    End If
                ElseIf x = 2 Then
                    Name = ViewState("Param2Name")
                    Type = ViewState("Param2Type")
                    If ViewState("Param2Ctrl") = "Textbox" Then
                        Value = txtParam2.Text
                    Else
                        Value = cboParam2.SelectedValue
                    End If
                ElseIf x = 3 Then
                    Name = ViewState("Param3Name")
                    Type = ViewState("Param3Type")
                    If ViewState("Param3Ctrl") = "Textbox" Then
                        Value = txtParam3.Text
                    Else
                        Value = cboParam3.SelectedValue
                    End If
                ElseIf x = 4 Then
                    Name = ViewState("Param4Name")
                    Type = ViewState("Param4Type")
                    If ViewState("Param4Ctrl") = "Textbox" Then
                        Value = txtParam4.Text
                    Else
                        Value = cboParam4.SelectedValue
                    End If
                End If

                paramValue = New localhost.ParameterValue
                paramValue.Name = Name
                If Type = localhost.ParameterTypeEnum.Boolean Then
                    If Value = "TRUE" Then
                        paramValue.Value = True
                    Else
                        paramValue.Value = False
                    End If
                ElseIf Type = localhost.ParameterTypeEnum.DateTime Then
                    paramValue.Value = CDate(Value)
                ElseIf Type = localhost.ParameterTypeEnum.Float Then
                    paramValue.Value = CDbl(Value)
                ElseIf Type = localhost.ParameterTypeEnum.Integer Then
                    paramValue.Value = CInt(Value)
                Else
                    paramValue.Value = Value
                End If
                parameters(x - 1) = paramValue
            Next
        Else
            parameters = Nothing
        End If

        Try
            ' Execute the report.
            report = oRS.Render(ReportPath, format, historyID, _
            devInfo, parameters, credentials, _
            showHideToggle, encoding, mimeType, _
            reportHistoryParameters, warnings, _
            streamIDs)

            ' For each image stream returned by the call to render,
            ' render the stream and save it to the application root.
            ' NOTE: The user that this application is running under must have write priveledges to
            ' the folder specified in the System.IO.File.OpenWrite method.
            For Each streamID In streamIDs
                resource = oRS.RenderStream(ReportPath, format, streamID, _
                historyID, devInfo, parameters, encoding, mimeType)

                Dim stream As System.IO.FileStream = _
                System.IO.File.OpenWrite("C:\Inetpub\wwwroot\RSWebServiceSample\Resources\" & streamID)

                stream.Write(resource, 0, CInt(resource.Length))
                stream.Close()
            Next

            sh.SessionId = oRS.SessionHeaderValue.SessionId

            ' Flush any pending response.
            Response.Clear()

            ' Set the HTTP headers for a PDF response.
            HttpContext.Current.Response.ClearHeaders()
            HttpContext.Current.Response.ClearContent()
            HttpContext.Current.Response.ContentType = "text/html"

            ' filename is the default filename displayed
            ' if the user does a save as.
            HttpContext.Current.Response.AppendHeader("Content-Disposition", "filename=""" & Mid(ReportPath, InStrRev(ReportPath, "/") + 1) & """")

            ' Send the byte array containing the report
            ' as a binary response.
            HttpContext.Current.Response.BinaryWrite(report)
            HttpContext.Current.Response.End()
        Catch ex As Exception
            If ex.Message <> "Thread was being aborted." Then
                HttpContext.Current.Response.ClearHeaders()
                HttpContext.Current.Response.ClearContent()
                HttpContext.Current.Response.ContentType = "text/html"
                HttpContext.Current.Response.Write( _
                "<HTML><BODY><H1>Error</H1><br><br>" & _
                ex.Message & "</BODY></HTML>")
                HttpContext.Current.Response.End()
            End If
        End Try
    End Sub

    Private Sub GetResourceContents(ByVal ResourcePath As String)
        Dim resource As Byte() = Nothing
        Dim mimeType As String = Nothing

        Try
            resource = oRS.GetResourceContents(ResourcePath, mimeType)

            ' Flush any pending response.
            Response.Clear()

            ' Set the HTTP headers for a PDF response.
            HttpContext.Current.Response.ClearHeaders()
            HttpContext.Current.Response.ClearContent()
            HttpContext.Current.Response.ContentType = mimeType

            ' filename is the default filename displayed
            ' if the user does a save as.
            HttpContext.Current.Response.AppendHeader("Content-Disposition", "filename=""" & Mid(ResourcePath, InStrRev(ResourcePath, "/") + 1) & """")

            ' Send the byte array containing the report
            ' as a binary response.
            HttpContext.Current.Response.BinaryWrite(resource)
            HttpContext.Current.Response.End()
        Catch ex As Exception
            If ex.Message <> "Thread was being aborted." Then
                HttpContext.Current.Response.ClearHeaders()
                HttpContext.Current.Response.ClearContent()
                HttpContext.Current.Response.ContentType = "text/html"
                HttpContext.Current.Response.Write( _
                "<HTML><BODY><H1>Error</H1><br><br>" & _
                ex.Message & "</BODY></HTML>")
                HttpContext.Current.Response.End()
            End If
        End Try
    End Sub

    Private Sub HideRight()
        lblPrompt.Visible = False
        txtInput.Visible = False
        lblOutput.Visible = False
        lstOutput.Visible = False
        lblReportParameters.Visible = False
        lblParam1.Visible = False
        lblParam2.Visible = False
        lblParam3.Visible = False
        lblParam4.Visible = False
        txtParam1.Visible = False
        txtParam2.Visible = False
        txtParam3.Visible = False
        txtParam4.Visible = False
        cboParam1.Visible = False
        cboParam2.Visible = False
        cboParam3.Visible = False
        cboParam4.Visible = False
        cmdExecuteReport.Visible = False
        cmdGeneric.Visible = False

    End Sub

    Private Sub btnOpen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOpen.Click
        Dim ListEntry As String
        Dim EntryType As String
        Dim Name As String

        ' Find the type of item that was clicked
        ListEntry = lstContent.Items(lstContent.SelectedIndex).Text
        EntryType = Left(ListEntry, 3)
        Name = Mid(ListEntry, 6)

        If EntryType = "DSC" Then
            GetDataSourceContents(lblPath.Text & "/" & Name)
        ElseIf EntryType = "FLD" Then
            If lblPath.Text = "/" Then
                lblPath.Text = lblPath.Text & Name
            Else
                lblPath.Text = lblPath.Text & "/" & Name
            End If

            GetFolderContents()
        ElseIf EntryType = "LNK" Or EntryType = "RPT" Then
            GetReportContents(lblPath.Text & "/" & Name)
        ElseIf EntryType = "RSC" Then
            GetResourceContents(lblPath.Text & "/" & Name)
        End If
    End Sub

    Private Sub btnBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack.Click
        Dim SlashPos As Integer
        Dim ListEntry As String
        Dim EntryType As String
        Dim Name As String

        ' Find and remove the last folder from the path.
        If lblPath.Text <> "/" Then
            SlashPos = InStrRev(lblPath.Text, "/")

            If SlashPos = 1 Then
                lblPath.Text = "/"
            Else
                lblPath.Text = Left(lblPath.Text, SlashPos - 1)
            End If

            GetFolderContents()
        End If
    End Sub

    Private Sub cmdExecuteReport_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExecuteReport.Click
        DisplayReport(ViewState("ReportPath"))
    End Sub

    Private Sub cmdExecuteMethod_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdExecuteMethod.Click
        Dim SelectedMethod As String
        Dim ListEntry As String
        Dim EntryType As String
        Dim Name As String
        Dim ItemPath As String

        ' Find the selected web service
        SelectedMethod = cboMethod.Items(cboMethod.SelectedIndex).Value

        ' Find the selected item
        If lstContent.Items.Count > 0 Then
            ListEntry = lstContent.Items(lstContent.SelectedIndex).Text
            EntryType = Left(ListEntry, 3)
            Name = Mid(ListEntry, 6)
            If lblPath.Text = "/" Then
                ItemPath = "/" & Name
            Else
                ItemPath = lblPath.Text & "/" & Name
            End If
        Else
            EntryType = "UNK"
            Name = ""
            ItemPath = ""
        End If

        ' Hide he items on the right side of the page.
        HideRight()

        If SelectedMethod = "CRFLD" Then
            lblPrompt.Text = "Enter the name of the new folder:"
            lblPrompt.Visible = True
            txtInput.Visible = True
            cmdGeneric.Text = "Create Folder"
            cmdGeneric.Visible = True
            ViewState.Add("ItemPath", lblPath.Text)
        ElseIf SelectedMethod = "CRRPT" Then
            lblPrompt.Text = "Enter the name of the new report:"
            lblPrompt.Visible = True
            txtInput.Visible = True
            cmdGeneric.Text = "Next >"
            cmdGeneric.Visible = True
            ViewState.Add("ItemPath", lblPath.Text)
        ElseIf SelectedMethod = "DELITEM" Then
            cmdGeneric.Text = "Confirm Delete"
            cmdGeneric.Visible = True
            ViewState.Add("ItemPath", ItemPath)
        ElseIf SelectedMethod = "GETEXECOPT" Then
            If EntryType = "RPT" Then
                Dim ScheduleDefinitionOrReference As localhost.ScheduleDefinitionOrReference = Nothing
                If oRS.GetExecutionOptions(ItemPath, ScheduleDefinitionOrReference) = localhost.ExecutionSettingEnum.Live Then
                    lblPrompt.Text = "This report will execute live."
                Else
                    lblPrompt.Text = "This report will execute from a snapshot."
                End If
                lblPrompt.Visible = True
            Else
                lblPrompt.Text = "A report must be selected in the Folder Content."
                lblPrompt.Visible = True
            End If
        ElseIf SelectedMethod = "GETEXTSET" Then
            Dim ExtensionParameters As localhost.ExtensionParameter()
            Dim ExtensionParameter As localhost.ExtensionParameter

            ExtensionParameters = oRS.GetExtensionSettings("Report Server Email")

            lblOutput.Text = "E-mail Delivery Parameters:"
            lblOutput.Visible = True
            lstOutput.Items.Clear()
            For Each ExtensionParameter In ExtensionParameters
                lstOutput.Items.Add(ExtensionParameter.DisplayName & ": " & ExtensionParameter.Value)
            Next
            lstOutput.Visible = True
        ElseIf SelectedMethod = "GETTYPE" Then
            Dim Type As localhost.ItemTypeEnum

            Type = oRS.GetItemType(ItemPath)

            If Type = localhost.ItemTypeEnum.DataSource Then
                lblPrompt.Text = "This is a data source"
            ElseIf Type = localhost.ItemTypeEnum.Folder Then
                lblPrompt.Text = "This is a folder"
            ElseIf Type = localhost.ItemTypeEnum.LinkedReport Then
                lblPrompt.Text = "This is a linked report"
            ElseIf Type = localhost.ItemTypeEnum.Report Then
                lblPrompt.Text = "This is a report"
            ElseIf Type = localhost.ItemTypeEnum.Resource Then
                lblPrompt.Text = "This is a resource"
            Else
                lblPrompt.Text = "This is an unknown item"
            End If
            lblPrompt.Visible = True
        ElseIf SelectedMethod = "GETPERM" Then
            Dim Permissions As String()
            Dim Permission

            Permissions = oRS.GetPermissions(ItemPath)

            lblOutput.Text = "Permissions:"
            lblOutput.Visible = True
            lstOutput.Items.Clear()
            For Each Permission In Permissions
                lstOutput.Items.Add(Permission)
            Next
            lstOutput.Visible = True
        ElseIf SelectedMethod = "GETPOL" Then
            Dim InheritFromParent As Boolean
            Dim Policies As localhost.Policy()
            Dim Policy As localhost.Policy
            Dim Role As localhost.Role

            Policies = oRS.GetPolicies(ItemPath, InheritFromParent)

            lblOutput.Text = "Security Policies:"
            lblOutput.Visible = True
            lstOutput.Items.Clear()

            If InheritFromParent Then
                lstOutput.Items.Add("Security is inherited from the parent folder.")
            Else
                lstOutput.Items.Add("Security is not inherited from the parent folder.")
            End If
            lstOutput.Items.Add("")
            For Each Policy In Policies
                lstOutput.Items.Add(Policy.GroupUserName & " is assigned to the following roles:")
                For Each Role In Policy.Roles
                    lstOutput.Items.Add(Role.Name)
                Next
                lstOutput.Items.Add("")
            Next
            lstOutput.Visible = True
        ElseIf SelectedMethod = "GETPROP" Then
            Dim ItemProperties As localhost.Property()
            Dim ItemProperty As localhost.Property

            ItemProperties = oRS.GetProperties(ItemPath, Nothing)

            lblOutput.Text = "Properties:"
            lblOutput.Visible = True
            lstOutput.Items.Clear()
            For Each ItemProperty In ItemProperties
                lstOutput.Items.Add(ItemProperty.Name & ": " & ItemProperty.Value)
            Next
            lstOutput.Visible = True
        ElseIf SelectedMethod = "GETRPTDSPROMPT" Then
            Dim Prompts As localhost.DataSourcePrompt()
            Dim Prompt As localhost.DataSourcePrompt

            If EntryType = "RPT" Then
                Prompts = oRS.GetReportDataSourcePrompts(ItemPath)

                lblOutput.Text = "Data Source Prompts:"
                lblOutput.Visible = True
                lstOutput.Items.Clear()
                For Each Prompt In Prompts
                    lstOutput.Items.Add(Prompt.Prompt)
                Next
                lstOutput.Visible = True
            Else
                lblPrompt.Text = "A report must be selected in the Folder Content."
                lblPrompt.Visible = True
            End If
        ElseIf SelectedMethod = "GETRPTDS" Then
            Dim DataSources As localhost.DataSource()
            Dim DataSource As localhost.DataSource

            If EntryType = "RPT" Then
                DataSources = oRS.GetReportDataSources(ItemPath)

                lblOutput.Text = "Data Sources:"
                lblOutput.Visible = True
                lstOutput.Items.Clear()
                For Each DataSource In DataSources
                    lstOutput.Items.Add(DataSource.Name)
                Next
                lstOutput.Visible = True
            Else
                lblPrompt.Text = "A report must be selected in the Folder Content."
                lblPrompt.Visible = True
            End If
        ElseIf SelectedMethod = "GETRPTDEF" Then
            If EntryType = "RPT" Then
                lblPrompt.Text = "Enter the full path and file name for the report definition:"
                lblPrompt.Visible = True
                txtInput.Visible = True
                cmdGeneric.Text = "Save Definition"
                cmdGeneric.Visible = True
                ViewState.Add("ItemPath", ItemPath)
            Else
                lblPrompt.Text = "A report must be selected in the Folder Content."
                lblPrompt.Visible = True
            End If
        ElseIf SelectedMethod = "GETRPTHISTLIMIT" Then
            Dim HistLimit As Integer
            Dim FromSystem As Boolean
            Dim SystemLimit As Integer

            If EntryType = "RPT" Then
                HistLimit = oRS.GetReportHistoryLimit(ItemPath, FromSystem, SystemLimit)

                lblOutput.Text = "Report History Limit:"
                lblOutput.Visible = True
                lstOutput.Items.Clear()
                If FromSystem Then
                    lstOutput.Items.Add("This limit comes from the system limit.")
                    lstOutput.Items.Add("")
                    lstOutput.Items.Add("The system limit is: " & CStr(SystemLimit))
                Else
                    lstOutput.Items.Add("This limit does not come from the system limit.")
                    lstOutput.Items.Add("")
                    lstOutput.Items.Add("The report history limit is: " & CStr(HistLimit))
                End If
                lstOutput.Visible = True
            Else
                lblPrompt.Text = "A report must be selected in the Folder Content."
                lblPrompt.Visible = True
            End If
        ElseIf SelectedMethod = "GETRPTHISTOPT" Then
            Dim Schedule As localhost.ScheduleDefinitionOrReference
            Dim HistoryEnabled As Boolean
            Dim KeepExecSnapshots As Boolean

            If EntryType = "RPT" Then
                HistoryEnabled = oRS.GetReportHistoryOptions(ItemPath, KeepExecSnapshots, Schedule)

                lblOutput.Text = "Report History Snapshots:"
                lblOutput.Visible = True
                lstOutput.Items.Clear()
                If HistoryEnabled Then
                    lstOutput.Items.Add("Report History Snapshots are enabled")
                    lstOutput.Items.Add("")
                    If KeepExecSnapshots Then
                        lstOutput.Items.Add("Execution Snapshots are saved as History")
                    Else
                        lstOutput.Items.Add("Execution Snapshots are not saved as History")
                    End If
                Else
                    lstOutput.Items.Add("Report History Snapshots are not enabled")
                End If
                lstOutput.Visible = True
            Else
                lblPrompt.Text = "A report must be selected in the Folder Content."
                lblPrompt.Visible = True
            End If
        ElseIf SelectedMethod = "GETRPTLINK" Then
            Dim Report As String

            If EntryType = "LNK" Then
                Report = oRS.GetReportLink(ItemPath)

                lblOutput.Text = "This report is linked to:"
                lblOutput.Visible = True
                lstOutput.Items.Clear()
                lstOutput.Items.Add(Report)
                lstOutput.Visible = True
            Else
                lblPrompt.Text = "A linked report must be selected in the Folder Content."
                lblPrompt.Visible = True
            End If
        ElseIf SelectedMethod = "GETSYSPERM" Then
            Dim Permissions As String()
            Dim Permission As String

            Permissions = oRS.GetSystemPermissions()

            lblOutput.Text = "System Permissions:"
            lblOutput.Visible = True
            lstOutput.Items.Clear()
            For Each Permission In Permissions
                lstOutput.Items.Add(Permission)
            Next
            lstOutput.Visible = True
        ElseIf SelectedMethod = "GETSYSPOL" Then
            Dim Policies As localhost.Policy()
            Dim Policy As localhost.Policy
            Dim Role As localhost.Role

            Policies = oRS.GetSystemPolicies()

            lblOutput.Text = "System Policies:"
            lblOutput.Visible = True
            lstOutput.Items.Clear()
            For Each Policy In Policies
                lstOutput.Items.Add(Policy.GroupUserName & " is assigned the following roles:")
                For Each Role In Policy.Roles
                    lstOutput.Items.Add(Role.Name)
                Next
                lstOutput.Items.Add("")
            Next
            lstOutput.Visible = True
        ElseIf SelectedMethod = "GETSYSPROP" Then
            Dim SystemProperties As localhost.Property()
            Dim SystemProperty As localhost.Property

            SystemProperties = oRS.GetSystemProperties(SystemProperties)

            lblOutput.Text = "System Properties:"
            lblOutput.Visible = True
            lstOutput.Items.Clear()
            For Each SystemProperty In SystemProperties
                lstOutput.Items.Add(SystemProperty.Name & ": " & SystemProperty.Value)
            Next
            lstOutput.Visible = True
        Else
            lblPrompt.Text = "Unknown "
            lblPrompt.Visible = True
        End If
    End Sub

    Private Sub cmdGeneric_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdGeneric.Click

        If cmdGeneric.Text = "Create Folder" Then
            Dim ItemPath As String

            ItemPath = ViewState("ItemPath")

            oRS.CreateFolder(txtInput.Text, ItemPath, Nothing)

            lblPrompt.Text = "Folder Created"
            txtInput.Visible = False
            cmdGeneric.Visible = False

            GetFolderContents()
        ElseIf cmdGeneric.Text = "Next >" Then
            lblPrompt.Text = "Enter the full path and file name of the report definition:"
            lblPrompt.Visible = True
            txtInput.Visible = True
            cmdGeneric.Text = "Create Report"
            cmdGeneric.Visible = True

            ViewState.Add("ReportName", txtInput.Text)
            txtInput.Text = ""
        ElseIf cmdGeneric.Text = "Create Report" Then
            Dim ItemPath As String
            Dim ReportName As String
            Dim ReportDef As Byte()

            Dim stream As FileStream = File.OpenRead(txtInput.Text)

            ReportDef = New [Byte](stream.Length) {}
            stream.Read(ReportDef, 0, CInt(stream.Length))
            stream.Close()

            ItemPath = ViewState("ItemPath")
            ReportName = ViewState("ReportName")

            oRS.CreateReport(ReportName, ItemPath, False, ReportDef, Nothing)

            lblPrompt.Text = "Folder Created"
            txtInput.Visible = False
            cmdGeneric.Visible = False

            GetFolderContents()
        ElseIf cmdGeneric.Text = "Confirm Delete" Then
            Dim ItemPath As String

            ItemPath = ViewState("ItemPath")

            oRS.DeleteItem(ItemPath)

            lblPrompt.Text = "Item Deleted"
            lblPrompt.Visible = True
            cmdGeneric.Visible = False

            GetFolderContents()
        ElseIf cmdGeneric.Text = "Save Definition" Then
            Dim ItemPath As String
            Dim ReportDefinition As Byte()
            Dim DataSource As localhost.DataSource
            Dim doc As New System.Xml.XmlDocument
            Dim ReportDefStream As MemoryStream

            ItemPath = ViewState("ItemPath")
            ReportDefinition = oRS.GetReportDefinition(ItemPath)
            ReportDefStream = New MemoryStream(ReportDefinition)
            doc.Load(ReportDefStream)
            doc.Save(txtInput.Text)

            lblPrompt.Text = "Report Definition Saved"
            txtInput.Visible = False
            cmdGeneric.Visible = False
        End If
    End Sub
End Class
